//**********************
// LCD header
// 
// (C)Copyright 2009 All rights reserved by Y.Onodera
// http://einst.hp.infoseek.co.jp
//**********************


// Select LCD type for locateLCD
//#define DISPLAY_8x1
#define DISPLAY_8x2
//#define DISPLAY_10x1
//#define DISPLAY_10x4
//#define DISPLAY_16x1
//#define DISPLAY_16x2
//#define DISPLAY_16x4
//#define DISPLAY_20x2
//#define DISPLAY_20x4
//#define DISPLAY_24x2
//#define DISPLAY_40x2
//#define DISPLAY_40x4	// not yet implementation


// Default 4 bits interface
// Comment out for 8 bits interface
//#define EIGHT_BIT_INTERFACE

// define data PIN assignment
#define DATA_PIN_7			LATEbits.LATE3
#define DATA_PIN_6			LATEbits.LATE2
#define DATA_PIN_5			LATEbits.LATE1
#define DATA_PIN_4			LATEbits.LATE0
//#define CFG_DATA_PIN_7		ADPCFGbits.PCFG7
//#define CFG_DATA_PIN_6		ADPCFGbits.PCFG6
//#define CFG_DATA_PIN_5		ADPCFGbits.PCFG5
//#define CFG_DATA_PIN_4		ADPCFGbits.PCFG4

#define READ_PIN_7			PORTEbits.RE3
#define READ_PIN_6			PORTEbits.RE2
#define READ_PIN_5			PORTEbits.RE1
#define READ_PIN_4			PORTEbits.RE0

#ifdef EIGHT_BIT_INTERFACE
#define DATA_PIN_3			LATBbits.LAB3
#define DATA_PIN_2			LATBbits.LAB2
#define DATA_PIN_1			LATBbits.LAB1
#define DATA_PIN_0			LATBbits.LAB0
#define CFG_DATA_PIN_3		ADPCFGbits.PCFG3
#define CFG_DATA_PIN_2		ADPCFGbits.PCFG2
#define CFG_DATA_PIN_1		ADPCFGbits.PCFG1
#define CFG_DATA_PIN_0		ADPCFGbits.PCFG0

#define READ_PIN_3			PORTBbits.RB3
#define READ_PIN_2			PORTBbits.RB2
#define READ_PIN_1			PORTBbits.RB1
#define READ_PIN_0			PORTBbits.RB0
#endif

#define TRIS_DATA_PIN_7		TRISEbits.TRISE3
#define TRIS_DATA_PIN_6		TRISEbits.TRISE2
#define TRIS_DATA_PIN_5		TRISEbits.TRISE1
#define TRIS_DATA_PIN_4		TRISEbits.TRISE0

#ifdef EIGHT_BIT_INTERFACE
#define TRIS_DATA_PIN_3		TRISBbits.TRISB3
#define TRIS_DATA_PIN_2		TRISBbits.TRISB2
#define TRIS_DATA_PIN_1		TRISBbits.TRISB1
#define TRIS_DATA_PIN_0		TRISBbits.TRISB0
#endif


// Define control PIN assignment
#define E_PIN				LATEbits.LATE8
#define RW_PIN				LATEbits.LATE5
#define RS_PIN				LATEbits.LATE4
#define TRIS_E				TRISEbits.TRISE8
#define TRIS_RW				TRISEbits.TRISE5
#define TRIS_RS				TRISEbits.TRISE4
//#define CFG_E_PIN			ADPCFGbits.PCFG5
//#define CFG_RW_PIN			ADPCFGbits.PCFG4
//#define CFG_RS_PIN			ADPCFGbits.PCFG3



// Instructions
#define CLEAR_DISPLAY		0x01	// Clear Display
#define RETURN_HOME			0x02	// Return Home
// for Entry Mode Set
#define INC_MODE			0x07	// Increment mode
#define DEC_MODE			0x05	// Decrement mode
#define SHIFT_OFF			0x06	// Do not Shift Display
#define SHIFT_ON			0x07	// Shift Display
// for Display ON/OFF Control
#define DISPLAY_ON			0x0f	// Display on
#define DISPLAY_OFF			0x0b	// Display off
#define CURSOR_ON			0x0f	// Cursor on
#define CURSOR_OFF			0x0d	// Cursor off
#define BLINK_ON			0x0f	// Cursor Blink
#define BLINK_OFF			0x0e	// Cursor No Blink
// for Cursor or Display Shift
#define SHIFT_CUR_LEFT		0x13	// Shift Cursor to the left
#define SHIFT_CUR_RIGHT		0x17	// Shift Cursor to the right
#define SHIFT_DISP_LEFT		0x1b	// Shift Display to the left
#define SHIFT_DISP_RIGHT	0x1f	// Shift Display to the right
// for Function Set
#define FOUR_BIT			0x2f	// 4-bit Interface
#define EIGHT_BIT			0x3f	// 8-bit Interface
#define ONE_LINE			0x37	// One line
#define TWO_LINE			0x3f	// Two lines
#define DOTS_5x8			0x3b	// 5x8 dots
#define DOTS_5x10			0x3f	// 5x10 dots


// Set Initial Mode for Function Set
#define INIT_MODE	(FOUR_BIT & TWO_LINE & DOTS_5x10)


// Function prototypes
void PutLCD(int rs, char a);
char GetLCD(int rs);
void InitLCD();
void ClsLCD();
void LocateLCD(int x, int y);
void PutsLCD(char *buffer);


#define	PutcLCD(a)	PutLCD(1, a)
#define	PutCmdLCD(a)	PutLCD(0, a)
#define	PutDatLCD(a)	PutLCD(1, a)
#define	GetCmdLCD()	GetLCD(0)
#define	GetDatLCD()	GetLCD(1)


