//**********************
// Wait Function without accuracy
// 
// Condition: define FCY
// Check Stopwatch
//
// (C)Copyright 2009 All rights reserved by Y.Onodera
// http://einst.hp.infoseek.co.jp
//**********************
#if defined(__dsPIC30F__)
#include <p30fxxxx.h>
#elif defined(__dsPIC33F__)
#include <p33Fxxxx.h>
#elif defined(__PIC24H__)
#include <p24Hxxxx.h>
#elif defined(__PIC24F__)
#include <p24Fxxxx.h>
#endif

//**********************
// When 7.37MHz Internal RC oscillator, 16x PLL enabled
// Fcy=7.37MHzx16/4
//**********************
//#define	FOSC	7372800	// internal RC
#define	FOSC	7000000UL
#define	PLL	4
#define	FCY	FOSC*PLL/4

#include <libpic30.h>


void WaitNus(unsigned int n)
{
#if PLL==1
	__delay32(FCY/1000000*n+50);
#else
	__delay32(FCY/1000000*n);
#endif
}


void WaitNms(unsigned int n)
{

	__delay32(FCY/1000*n);

}


void WaitNs(unsigned int n)
{

	unsigned long i;
	for(i=0;i<n;i++)
		__delay32(FCY);

}
